--- /opt/context/tex/texmf-context/tex/context/base/core-con.lua	2009-12-21 15:26:29.000000000 +0800
+++ core-con.lua	2009-12-23 10:02:02.000000000 +0800
@@ -309,7 +309,7 @@
 
 local vector = {
     normal = {
-                [0] = "○",
+                [0] = "〇",
                 [1] = "一",
                 [2] = "二",
                 [3] = "三",
@@ -343,7 +343,7 @@
         [100000000] = "亿",
     },
     all = {
-                [0] = "○",
+                [0] = "〇",
                 [1] = "一",
                 [2] = "二",
                 [3] = "三",
@@ -371,39 +371,56 @@
             break
         elseif n >= 100000000 then
             local m = floor(n/100000000)
-            if m > 1 then result[#result+1] = tochinese(m) end
+            result[#result+1] = tochinese(m,name)
             result[#result+1] = vector[100000000]
+	    local z =  n - m * 100000000
+	    if z > 0 and z < 10000000 then result[#result+1] = vector[0] end
             n = n % 100000000
         elseif n >= 10000000 then
-            result[#result+1] = tochinese(floor(n/10000))
+ 	    local m = floor(n/10000)
+            result[#result+1] = tochinese(m,name)
             result[#result+1] = vector[10000]
+	    local z =  n - m * 10000 
+	    if z > 0 and z < 1000 then result[#result+1] = vector[0] end
             n = n % 10000
         elseif n >= 1000000 then
-            result[#result+1] = tochinese(floor(n/10000))
+	    local m = floor(n/10000)
+            result[#result+1] = tochinese(m,name)
             result[#result+1] = vector[10000]
+	    local z =  n - m * 10000 
+	    if z > 0 and z < 1000 then result[#result+1] = vector[0] end
             n = n % 10000
         elseif n >= 100000 then
-            result[#result+1] = tochinese(floor(n/10000))
+	    local m = floor(n/10000)
+            result[#result+1] = tochinese(m,name)
             result[#result+1] = vector[10000]
+	    local z = n - m * 10000
+	    if z > 0 and z < 1000 then result[#result+1] = vector[0] end	    
             n = n % 10000
         elseif n >= 10000 then
             local m = floor(n/10000)
-            if m > 1 then result[#result+1] = vector[m] end
+            result[#result+1] = vector[m]
             result[#result+1] = vector[10000]
+	    local z =  n - m * 10000
+	    if z > 0 and z < 1000 then result[#result+1] = vector[0] end
             n = n % 10000
         elseif n >= 1000 then
             local m = floor(n/1000)
-            if m > 1 then result[#result+1] = vector[m] end
+            result[#result+1] = vector[m]
             result[#result+1] = vector[1000]
+	    local z =  n - m * 1000
+	    if z > 0 and z < 100 then result[#result+1] = vector[0] end
             n = n % 1000
         elseif n >= 100 then
             local m = floor(n/100)
-            if m > 1 then result[#result+1] = vector[m] end
+            result[#result+1] = vector[m]
             result[#result+1] = vector[100]
+	    local z = n - m * 100
+	    if z > 0 and z < 10 then result[#result+1] = vector[0] end
             n = n % 100
         elseif n >= 10 then
             local m = floor(n/10)
-            if vector[m*10] then
+            if m > 1 and vector[m*10] then
                 result[#result+1] = vector[m*10]
             else
                 result[#result+1] = vector[m]
@@ -415,6 +432,9 @@
             break
         end
     end
+    if (result[1] == vector[1] and result[2] == vector[10]) then
+	result[1] = ""
+    end
     return concat(result)
 end
 
